// BaseWindow.cpp : Cve[V t@C
//

#include "stdafx.h"

#include "TmpFavGroup.h"
#include "TmpFavTreeView.h"
#include "BaseWindow.h"
#include "DonutApi.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char 		   THIS_FILE[] = __FILE__;
#endif

extern CTmpFavGroupApp theApp;



/////////////////////////////////////////////////////////////////////////////
// CBaseWindow

CBaseWindow::CBaseWindow()
{
}


CBaseWindow::~CBaseWindow()
{
}


BEGIN_MESSAGE_MAP(CBaseWindow, CWnd)
	//{{AFX_MSG_MAP(CBaseWindow)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_COMMAND(ID_OPEN_ACTIVE	, OnOpenActive		)
	ON_WM_DESTROY()
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_OPEN_DBLCLICK	, OnOpenDblclick	)
	ON_COMMAND(ID_OPENANDCLOSE	, OnOpenandclose	)
	ON_COMMAND(ID_ADDITEMTOGROUP, OnAddItemToGroup	)
	ON_COMMAND(ID_ADD_TMPGROUP	, OnAddTmpgroup		)
	ON_COMMAND(ID_GROUP_DELETE	, OnGroupDelete		)
	ON_COMMAND(ID_RELOAD_FOLDER	, OnReloadFolder	)
	ON_COMMAND(ID_GROUP_OPEN	, OnGroupOpen		)
	ON_COMMAND(ID_ITEM_PROPERTY	, OnItemProperty	)
	ON_COMMAND(ID_ITEM_DELETE	, OnItemDelete		)
	ON_COMMAND(ID_RENAME_GROUP	, OnRenameGroup		)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////
// CBaseWindow bZ[W nh

int CBaseWindow::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	ReadProfile();								//ݒǂݍ

	//c[r[쐬
	RECT	rc		= { 0, 0, lpCreateStruct->cx , lpCreateStruct->cy };
	m_Tree.Create(WS_CHILD | WS_VISIBLE | TVS_INFOTIP | TVS_SHOWSELALWAYS | TVS_SINGLEEXPAND | TVS_FULLROWSELECT | TVS_TRACKSELECT, rc, this, 1);

	//f[^tH_̃pX擾
	CString 	strPath = GetDataFolderPath();

	//C[WXg̐ݒ
	SetImageList();

	//f[^[h
	m_Tree.LoadFavGroups(strPath);

	//ɗ]T
	m_Tree.SetItemHeight(m_Tree.GetItemHeight() + 4);

	//X|X̂ł炩ߍڂIĂ
	m_Tree.SelectItem( m_Tree.GetChildItem(TVI_ROOT) );

	return 0;
}


//DestroyWindowꂽƂ
void CBaseWindow::OnDestroy()
{
	CWnd::OnDestroy();
	WriteProfile(); 							//ݒۑ
}


//tH[JXݒ肳ꂽƂ
void CBaseWindow::OnSetFocus(CWnd *pOldWnd)
{
	CWnd::OnSetFocus(pOldWnd);
	::SetFocus(m_Tree.m_hWnd);					//c[r[ɃtH[JX킹
}


//TCYύXv
void CBaseWindow::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);
	m_Tree.MoveWindow(0, 0, cx, cy, TRUE);		//vꂽTCYɍ킹
}


//Õrbg}bvt@CgpACRǂݍŎgp
void CBaseWindow::SetImageList()
{
	CString 	strIcoPath = GetDataFolderPath() + _T("ico.bmp");

	HBITMAP hBmp;
	hBmp = (HBITMAP) LoadImage(theApp.m_hInstance, strIcoPath.GetBuffer(0), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_DEFAULTCOLOR);
	if (hBmp == NULL)
		hBmp = LoadBitmap( theApp.m_hInstance, MAKEINTRESOURCE(IDB_TREEICON) );		//Ot@CƂ̓\[Xǂݍ
	if (hBmp == NULL)
		return;

	CBitmap 	bmp;
	bmp.Attach(hBmp);
	m_imgs.Create(16, 16, ILC_MASK | ILC_COLOR24, 1, 1);
	m_imgs.Add( &bmp, RGB(255, 0, 255) );

	m_Tree.SetImageList(&m_imgs, TVSIL_NORMAL); //C[WXgZbg
}


//fBNg̃pX
CString CBaseWindow::GetSelfDir()
{
	CString strPath = GetSelfPath();
	int 	nPos	= strPath.ReverseFind('\\');
	if (nPos)
		strPath = strPath.Left(nPos + 1);
	else
		return _T("");

	return strPath;
}


CString CBaseWindow::GetSelfPath()
{
	CString strPath;
	DWORD	dwSize = MAX_PATH;
	::GetModuleFileName(theApp.m_hInstance, strPath.GetBuffer(dwSize), dwSize);
	strPath.ReleaseBuffer();
	return strPath;
}


CString CBaseWindow::GetDataFolderPath()
{
	CString strPath  = GetSelfPath();
	int 	nPos	 = strPath.ReverseFind('\\');
	CString strTitle = strPath.Mid(nPos + 1);
	strPath  = strPath.Left(nPos + 1);
	if ( (nPos = strTitle.ReverseFind('.')) > 0 )
		strTitle = strTitle.Left(nPos);

	strPath += strTitle;
	strPath += "_Dat\\";

	return strPath;
}


//ݒt@CIvVǂݍ
void CBaseWindow::ReadProfile()
{
	CIniSection pr;
	CString 	strPath = GetDataFolderPath();

	if ( strPath.IsEmpty() )
		return;

	strPath += _T("setting.ini");

	DWORD		dwStyle = 0;
	pr.Open( strPath, _T("Main") );
	pr.QueryValue( dwStyle, _T("ExtendedStyle") );
	pr.Close();

	m_Tree.SetExtendedStyle(dwStyle);
}


//ݒt@CɃIvVo
void CBaseWindow::WriteProfile()
{
	DWORD		dwStyle = m_Tree.GetExtendedStyle();
	CIniSection pr;
	CString 	strPath = GetDataFolderPath();
	if ( strPath.IsEmpty() )
		return;

	strPath += _T("setting.ini");

	pr.Open( strPath, _T("Main") );
	pr.SetValue( dwStyle, _T("ExtendedStyle") );
	pr.Close();
}


void CBaseWindow::SetCheckOfMenu(CMenu &menu, UINT uItemID, DWORD dwFlag)
{
	BOOL bCheck = (m_Tree.GetExtendedStyle() & dwFlag) ? TRUE : FALSE;

	menu.CheckMenuItem( uItemID, MF_BYCOMMAND | ( (bCheck) ? MF_CHECKED : MF_UNCHECKED ) );
}


//vOC`̃j[[hẴnhn
//gIDeleteMenu邱
HMENU CBaseWindow::LoadPluginMenu()
{
	CMenu 	menu;

	menu.LoadMenu(IDR_MENU);
	SetCheckOfMenu(menu, ID_OPEN_ACTIVE  , TMPFAV_ACTIVE);
	SetCheckOfMenu(menu, ID_OPENANDCLOSE , TMPFAV_CLOSE);
	SetCheckOfMenu(menu, ID_OPEN_DBLCLICK, TMPFAV_DBLCLICK);

	HMENU hMenu = menu.Detach();
	return hMenu;
}


void CBaseWindow::ToggleOptionFlag(DWORD dwFlag)
{
	DWORD dwStyle = m_Tree.GetExtendedStyle();
	dwStyle 	 ^= dwFlag;
	m_Tree.SetExtendedStyle(dwStyle);
}


//IvV̕ύX
void CBaseWindow::OnOpenActive()
{
	ToggleOptionFlag(TMPFAV_ACTIVE);
}


void CBaseWindow::OnOpenDblclick()
{
	ToggleOptionFlag(TMPFAV_DBLCLICK);
}


void CBaseWindow::OnOpenandclose()
{
	ToggleOptionFlag(TMPFAV_CLOSE);
}


//R}hEnhiقƂTreeViewŗpӂ֐Ăяoj
void CBaseWindow::OnAddItemToGroup()
{
	m_Tree.AddItemToGroup();
}


void CBaseWindow::OnAddTmpgroup()
{
	m_Tree.SaveGroup();
}


void CBaseWindow::OnGroupDelete()
{
	m_Tree.DeleteGroup();
}


void CBaseWindow::OnReloadFolder()
{
	m_Tree.DeleteAllItems();
	CString strPath = GetDataFolderPath();
	m_Tree.LoadFavGroups(strPath);
}


void CBaseWindow::OnGroupOpen()
{
	m_Tree.OpenFavGroup();
}


void CBaseWindow::OnItemProperty()
{
	m_Tree.SetItemOption();
}


void CBaseWindow::OnItemDelete()
{
	m_Tree.DeleteGroupItem();
}


void CBaseWindow::OnRenameGroup()
{
	m_Tree.RenameGroup();
}
